GraphicsDevice

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class GraphicsDevice

    java.lang.Object
      java.awt.GraphicsDevice

    public abstract class GraphicsDevice

extends Object

The `GraphicsDevice` class describes the graphics devices that might be available in a particular graphics environment. These include screen and printer devices. Note that there can be many screens and many printers in an instance of `GraphicsEnvironment`. Each graphics device has one or more `GraphicsConfiguration` objects associated with it. These objects specify the different configurations in which the `GraphicsDevice` can be used.

In a multi-screen environment, the `GraphicsConfiguration` objects can be used to render components on multiple screens. The following code sample demonstrates how to create a `Frame` object on each screen device in the `GraphicsEnvironment`:

       GraphicsEnvironment ge = GraphicsEnvironment.
       getLocalGraphicsEnvironment();
       GraphicsDevice[] gs = ge.getScreenDevices();
       for (int j = 0; j < gs.length; j++) {
          GraphicsDevice gd = gs[j];

          Frame f = new
          Frame(gd.getDefaultConfiguration());
          f.show();
       }

#### Clarifications

The following clarifications apply to implementations of this Profile:

- The size and location of Frame instances may be severely limited in this profile. Please see the note concerning size and location of `java.awt.Window`. As a consequence, a `Frame` in full screen mode need not span the entire screen.
  See:
  - Size and location of `java.awt.Window`
  - `setFullScreenWindow(Window)`

Version:
  1.27, 01/23/03
See Also:
  `GraphicsEnvironment`, `GraphicsConfiguration`

Field Summary
`static int` | `TYPE_IMAGE_BUFFER` Device is an image buffer.
`static int` | `TYPE_PRINTER` Device is a printer.
`static int` | `TYPE_RASTER_SCREEN` Device is a raster screen.

Method Summary
`abstract int` | `getAvailableAcceleratedMemory()` This method returns the number of bytes available in accelerated memory on this device.
`abstract GraphicsConfiguration[]` | `getConfigurations()` Returns all of the `GraphicsConfiguration` objects associated with this `GraphicsDevice`.
`abstract GraphicsConfiguration` | `getDefaultConfiguration()` Returns the default `GraphicsConfiguration` associated with this `GraphicsDevice`.
`abstract Window` | `getFullScreenWindow()` Returns the `Window` object representing the full-screen window if the device is in full-screen mode and the `Window` is in the same context as the calling thread.
`abstract String` | `getIDstring()` Returns the identification string associated with this `GraphicsDevice`.
`abstract int` | `getType()` Returns the type of this `GraphicsDevice`.
`abstract boolean` | `isFullScreenSupported()` Returns `true` if this `GraphicsDevice` supports full-screen exclusive mode.
`abstract void` | `setFullScreenWindow(Window w)` Enter full-screen mode, or return to windowed mode.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### TYPE_RASTER_SCREEN

    public static final int TYPE_RASTER_SCREEN

  Device is a raster screen.

  See Also:
    Constant Field Values

### TYPE_PRINTER

    public static final int TYPE_PRINTER

  Device is a printer.

  See Also:
    Constant Field Values

### TYPE_IMAGE_BUFFER

    public static final int TYPE_IMAGE_BUFFER

  Device is an image buffer. This buffer can reside in device or system memory but it is not physically viewable by the user.

  See Also:
    Constant Field Values

Method Detail

### getType

    public abstract int getType()

  Returns the type of this `GraphicsDevice`.

  Returns:
    the type of this `GraphicsDevice`, which can either be TYPE_RASTER_SCREEN, TYPE_PRINTER or TYPE_IMAGE_BUFFER.
  See Also:
    `TYPE_RASTER_SCREEN`, `TYPE_PRINTER`, `TYPE_IMAGE_BUFFER`

### getIDstring

    public abstract String getIDstring()

  Returns the identification string associated with this `GraphicsDevice`.

  A particular program might use more than one `GraphicsDevice` in a `GraphicsEnvironment`. This method returns a `String` identifying a particular `GraphicsDevice` in the local `GraphicsEnvironment`. Although there is no public method to set this `String`, a programmer can use the `String` for debugging purposes. Vendors of the JavaTM Runtime Environment can format the return value of the `String`. To determine how to interpret the value of the `String`, contact the vendor of your Java Runtime. To find out who the vendor is, from your program, call the `getProperty` method of the System class with "java.vendor".

  Returns:
    a `String` that is the identification of this `GraphicsDevice`.

### getConfigurations

    public abstract GraphicsConfiguration[] getConfigurations()

  Returns all of the `GraphicsConfiguration` objects associated with this `GraphicsDevice`.

  Returns:
    an array of `GraphicsConfiguration` objects that are associated with this `GraphicsDevice`.

### getDefaultConfiguration

    public abstract GraphicsConfiguration getDefaultConfiguration()

  Returns the default `GraphicsConfiguration` associated with this `GraphicsDevice`.

  Returns:
    the default `GraphicsConfiguration` of this `GraphicsDevice`.

### isFullScreenSupported

    public abstract boolean isFullScreenSupported()

  Returns `true` if this `GraphicsDevice` supports full-screen exclusive mode.

  Returns:
    whether full-screen exclusive mode is available for this graphics device
  Since:
    1.4

### setFullScreenWindow

    public abstract void setFullScreenWindow(Window w)

  Enter full-screen mode, or return to windowed mode.

  If `isFullScreenSupported` returns `true`, full screen mode is considered to be exclusive, which implies:

  - Windows cannot overlap the full-screen window. All other application windows will always appear beneath the full-screen window in the Z-order.
  - Input method windows are disabled. It is advisable to call `Component.enableInputMethods(false)` to make a component a non-client of the input method framework.

  If `isFullScreenSupported` returns `false`, full-screen exclusive mode is simulated by resizing the window to the size of the screen and positioning it at (0,0).

  Please note the clarification for this method.

  Parameters:
    `w` - a window to use as the full-screen window; `null` if returning to windowed mode.
  Since:
    1.4
  See Also:
    `isFullScreenSupported()`, `getFullScreenWindow()`, `Component.enableInputMethods(boolean)`

### getFullScreenWindow

    public abstract Window getFullScreenWindow()

  Returns the `Window` object representing the full-screen window if the device is in full-screen mode and the `Window` is in the same context as the calling thread.

  Returns:
    the full-screen window if the device is in full-screen mode and the `Window` is in the same context as the calling thread; `null` otherwise.
  Since:
    1.4
  See Also:
    `setFullScreenWindow(Window)`

### getAvailableAcceleratedMemory

    public abstract int getAvailableAcceleratedMemory()

  This method returns the number of bytes available in accelerated memory on this device. Some images are created or cached in accelerated memory on a first-come, first-served basis. On some operating systems, this memory is a finite resource. Calling this method and scheduling the creation and flushing of images carefully may enable applications to make the most efficient use of that finite resource.
  Note that the number returned is a snapshot of how much memory is available; some images may still have problems being allocated into that memory. For example, depending on operating system, driver, memory configuration, and thread situations, the full extent of the size reported may not be available for a given image. There are further inquiry methods on the `ImageCapabilities` object associated with a VolatileImage that can be used to determine whether a particular VolatileImage has been created in accelerated memory.

  Returns:
    number of bytes available in accelerated memory. A negative return value indicates that accelerated memory is unlimited.
  See Also:
    `VolatileImage.flush()`, `ImageCapabilities.isAccelerated()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD